<?php 
/**
 * WooCommerce UUID Test Plugin Functions
 *
 * @author   d.stanisheva
 * @package  woo-uuid
 * @since    1.0.0
 */
// CUSTOM TIME INTERVAL
	add_filter('cron_schedules', 'woouuid_cron_add_intervals');
	function woouuid_cron_add_intervals( $schedules ) {
	  $schedules['checkuuid'] = array(
	    'interval' => 300,
	    'display' => __('Every 5min')
	  );
	  return $schedules;
	}

// SETUP CRON
     register_activation_hook(__FILE__, 'woouuid_schedule_cron');

	add_action('wp', 'woouuid_schedule_cron');
	function woouuid_schedule_cron() {
	  if ( !wp_next_scheduled( 'woouuid_cron' ) )
	    wp_schedule_event(time(), 'checkuuid', 'woouuid_cron');
	}


// the CRON hook for firing function
	add_action('woouuid_cron', 'woouuid_cron_function');
       // add_action('wp_head', 'woouuid_cron_function'); //test on page load

	function get_processing_orders() {
	   global $wpdb;
	   $processing_orders = $wpdb->get_col(
	      $wpdb->prepare(
		 "SELECT posts.ID
		 FROM {$wpdb->prefix}posts AS posts
		 WHERE posts.post_type = 'shop_order'
		 AND posts.post_status = 'wc-on-hold'
	         ")
	   );
	   return $processing_orders;
	}

	function woouuid_cron_function() {
	   
	    //wp_mail('dast@abv.bg','Cron Worked', date('r'));
                $warehouseID    = get_option( 'warehouseid', true );
		$orders = get_processing_orders();
		$email_subject = "Hold Orders Email Digest_". $warehouseID;
	        $email_content = "Hold Order IDs: " . implode( "|", $orders );
	        //wp_mail( 'dast@abv.bg', $email_subject, $email_content );

		foreach( $orders as $orderID){

			$order = wc_get_order( $orderID );
		        $order_data = $order->get_data(); // The Order data

			$sendData = new Send_Data_Api_Icash();

		        $contragentID = $sendData->getContragent($order_data ['billing']);
		     
			$onlineSettings = $sendData->getOnlineSettings();

			$operationData = $sendData->newOperation($orderID, $contragentID, $onlineSettings['data']['store'], $onlineSettings['data']['chred'] );
		
			if($operationData == false){
		                $text = $warehouseID . " : ".date('r');
		                $text = $text . "  Cashregister`s online shop does not work ...receipt does not print:".$orderID;
				//wp_mail('dast@abv.bg','Cron Worked_'.$warehouseID, $text);	
				continue;
			}

			$order_payment_method = $order_data['payment_method'];
		        
			$sendData->addOperationSaleItem($order, $operationData['operationID']);
	 		$sendData->addShippingMethod($order, $operationData['operationID'], $order_payment_method, $onlineSettings);
			
			if(isset($operationData['uuid']) && !empty($operationData['uuid'])){
				
				$sendData->copmleteOperation($operationData['operationID'], $order_payment_method, $onlineSettings);
			
				//update order :  uuid + status
		
		        	$order->update_status('printeduuid');	  
				$order->update_meta_data( 'uuid', $operationData['uuid']);
				$order->save();		
			}  
		}
	}


