<?php
/**
 * Plugin Name: Icash tax admin bg
 * Plugin URI: https://v5.icash.bg
 * Author: develop icash
 * Version: 1.0.2
 * Description: Print cash receipt and get UUID (Api icash)
 * Text Domain: woo-uuid
 * @package woo-uuid
 */

/**
 * Check if WooCommerce is active
 **/
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ), true ) ) {

	/**
	* Localisation
	*/
	load_plugin_textdomain( 'woo-uuid', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );

	if ( ! class_exists( 'Woo_uuid' ) ) {

	/**
	* Cart Tab class
	*/
		class Woo_uuid{

			/**
			* The token.
			*
			* @var     string
			* @access  public
			* @since   1.1.1
			*/
			public $token;

			/**
			* The version number.
			*
			* @var     string
			* @access  public
			* @since   1.1.1
			*/
			public $version;

			public static $plugin_url;
			public static $plugin_path;
			public static $plugin_basefile;
			public static $plugin_basefile_path;
			public static $plugin_text_domain;

			/**
			* Set up all the things
			*/
			public function __construct() {
				$this->token   = 'woo-uuid';
				$this->version = '1.0.2';
				$this->setup();
				$this->define_constants();
				register_activation_hook( __FILE__, array( $this, 'install' ) );
				add_action( 'init', array( $this, 'localise' ) );
			}

			/**
			* Installation.
			* Runs on activation. Logs the version number.
			*
			* @access  public
			* @since   1.1.1
			* @return  void
			*/
			public function install() {
				update_option( $this->token . '-version', $this->version );
			}

			/**
			* Setup
			*
			* @return void
			*/
			public function setup() {
		
				include_once( 'includes/settings-form.php');
				include_once( 'includes/addPrintUUIDStatus.php');
				include_once( 'includes/cronCheckPendingOrder.php');
				include_once( 'includes/sendDataApiIcash.php');

			}
			
			/**
			 * Load the localisation 
			 */
			public function localise() {							
				// Load language files from the wp-content/languages/plugins folder
				$mo_file = WP_LANG_DIR . '/plugins/' . self::$plugin_text_domain . '-' . get_locale() . '.mo';

				if( is_readable( $mo_file ) ) {
					load_textdomain( self::$plugin_text_domain, $mo_file );
				}

				// Otherwise load them from the plugin folder
				load_plugin_textdomain( self::$plugin_text_domain, false, dirname( self::$plugin_basefile ) . '/languages/' );
			}

			private function define_constants() {
				self::$plugin_basefile_path = __FILE__;
				self::$plugin_basefile = plugin_basename( self::$plugin_basefile_path );
				self::$plugin_url = plugin_dir_url( self::$plugin_basefile );
				self::$plugin_path = trailingslashit( dirname( self::$plugin_basefile_path ) );	
				self::$plugin_text_domain = trim( dirname( self::$plugin_basefile ) );		
			}
		}

		$testwoo= new Woo_uuid();
	}	


	add_action( 'woocommerce_before_checkout_process', function() {
		$warehouseID    = get_option( 'warehouseid', true );
		//$cashregisterID = get_option( 'cashregisterid', true );
		$domain   = get_option( 'domain', true );

                if($warehouseID > 0) {
			$url = 'http://'.$domain.'/default/Woocommerce/checkcashregister?whid='.$warehouseID;

			$response = wp_remote_get( $url);

			if( is_wp_error( $response ) ) {
				return false; // Bail early
			}

			$body = wp_remote_retrieve_body( $response );

			$data = json_decode( $body );
		
			if( ! empty( $data ) ) {

				if($data->response->error == 'OFFLINE'){ 
                                        //'$text = _e( 'The cash register does not include.', 'woo-uuid' );

					wc_add_notice(__( 'The cash register does not include.', 'woo-uuid' ), 'error' );
				};
			}   
		}                             

	});
//old
/*	add_action( 'woocommerce_checkout_order_processed', function($orderID) {
		
		$warehouseID    = get_option( 'warehouseid', true );
		$url    = get_option( 'domain', true );

		if($warehouseID > 0){
			$url = 'http://'.$url.'/default/Woocommerce/saveorder?id='.$orderID.'&whid='.$warehouseID ;

			$args = array(
			    'timeout'     => 50,
			    'redirection' => 5,
			    'httpversion' => '1.0',
			    'user-agent'  => 'WordPress/' . $wp_version . '; ' . home_url(),
			    'blocking'    => true,
			    'headers'     => array(),
			    'cookies'     => array(),
			    'body'        => null,
			    'compress'    => false,
			    'decompress'  => true,
			    'sslverify'   => true,
			    'stream'      => false,
			    'filename'    => null
			); 	

			$response = wp_remote_get( $url, $args);

			if( is_wp_error( $response ) ) {
				//return false; // Bail early
			}

			
                        $responceData = json_decode(wp_remote_retrieve_body( $response ), TRUE );
        
        		//$uuid= $responceData['uuid'];
			//$order->update_meta_data( 'uuid1', "test" );
                	//$order->update_status('printeduuid', 'order_note');
	    		//$order->save();	  	
		
		}
	});*/


//new
	add_action( 'woocommerce_checkout_order_processed', function($orderID) {
		global $woocommerce;
		$checkout_url = $woocommerce->cart->get_checkout_url();
		$order = wc_get_order( $orderID );
                $order_data = $order->get_data(); // The Order data

		$sendData = new Send_Data_Api_Icash();
  
		//$orderID = intval( $_GET['order_id'] );

                $contragentID = $sendData->getContragent($order_data ['billing']);
             
		$onlineSettings = $sendData->getOnlineSettings();
                
		$operationData = $sendData->newOperation($orderID, $contragentID, $onlineSettings['data']['store'], $onlineSettings['data']['chred']);
		
		if($operationData == false){
			wc_add_notice( __( 'Няма включена каса!' ), 'error' );
			return;
		}
		
		$order_payment_method = $order_data['payment_method'];
                $sendData->addOperationSaleItem($order, $operationData['operationID']);
 		$sendData->addShippingMethod($order, $operationData['operationID'], $order_payment_method, $onlineSettings);

		if(isset($operationData['uuid']) && !empty($operationData['uuid'])){
			
			$sendData->copmleteOperation($operationData['operationID'], $order_payment_method, $onlineSettings);
			
			//update order :  uuid + status
		
                	$order->update_status('printeduuid');	  
			$order->update_meta_data( 'uuid', $operationData['uuid']);	
			$order->save();	
		}
	});


}
